package dev.yeff.orbital.io;

import lombok.Getter;

import static com.raylib.Raylib.*;

public enum Keys {
    // Keyboard keys
    Q(KEY_Q),
    W(KEY_W),
    E(KEY_E),
    R(KEY_R),
    T(KEY_T),
    Y(KEY_Y),
    U(KEY_U),
    I(KEY_I),
    O(KEY_O),
    P(KEY_P),
    A(KEY_A),
    S(KEY_S),
    D(KEY_D),
    F(KEY_F),
    G(KEY_G),
    H(KEY_H),
    J(KEY_J),
    K(KEY_K),
    L(KEY_L),
    Z(KEY_Z),
    X(KEY_X),
    C(KEY_C),
    V(KEY_V),
    B(KEY_B),
    N(KEY_N),
    M(KEY_M),
    NUM_0(KEY_ZERO),
    NUM_1(KEY_ONE),
    NUM_2(KEY_TWO),
    NUM_3(KEY_THREE),
    NUM_4(KEY_FOUR),
    NUM_5(KEY_FIVE),
    NUM_6(KEY_SIX),
    NUM_7(KEY_SEVEN),
    NUM_8(KEY_EIGHT),
    NUM_9(KEY_NINE),
    ARROW_UP(KEY_UP),
    ARROW_DOWN(KEY_DOWN),
    ARROW_LEFT(KEY_LEFT),
    ARROW_RIGHT(KEY_RIGHT),
    LEFT_ALT(KEY_LEFT_ALT),
    RIGHT_ALT(KEY_RIGHT_ALT),
    LEFT_CTRL(KEY_LEFT_CONTROL),
    RIGHT_CTRL(KEY_RIGHT_CONTROL),
    SUPER(KEY_LEFT_SUPER),
    APOSTROPHE(KEY_APOSTROPHE),
    COMMA(KEY_COMMA),
    MINUS(KEY_MINUS),
    PERIOD(KEY_PERIOD),
    SLASH(KEY_SLASH),
    SEMICOLON(KEY_SEMICOLON),
    EQUAL(KEY_EQUAL),
    TILDE(KEY_GRAVE),
    BACKSLASH(KEY_BACKSLASH),
    LEFT_BRACKET(KEY_LEFT_BRACKET),
    RIGHT_BRACKET(KEY_RIGHT_BRACKET),
    SPACE(KEY_SPACE),
    ESC(KEY_ESCAPE),
    ENTER(KEY_ENTER),
    TAB(KEY_TAB),
    BACKSPACE(KEY_BACKSPACE),
    INSERT(KEY_INSERT),
    DELETE(KEY_DELETE),
    PAGE_UP(KEY_PAGE_UP),
    PAGE_DOWN(KEY_PAGE_DOWN),
    HOME(KEY_HOME),
    END(KEY_END),
    CAPS_LOCK(KEY_CAPS_LOCK),
    SCROLL_LOCK(KEY_SCROLL_LOCK),
    NUM_LOCK(KEY_NUM_LOCK),
    PRINT_SCREEN(KEY_PRINT_SCREEN),
    PAUSE(KEY_PAUSE),
    F1(KEY_F1),
    F2(KEY_F2),
    F3(KEY_F3),
    F4(KEY_F4),
    F5(KEY_F5),
    F6(KEY_F6),
    F7(KEY_F7),
    F8(KEY_F8),
    F9(KEY_F9),
    F10(KEY_F10),
    F11(KEY_F11),
    F12(KEY_F12),
    LEFT_SHIFT(KEY_LEFT_SHIFT),
    RIGHT_SHIFT(KEY_RIGHT_SHIFT),
    KB_MENU(KEY_KB_MENU),
    KEYPAD_0(KEY_KP_0),
    KEYPAD_1(KEY_KP_1),
    KEYPAD_2(KEY_KP_2),
    KEYPAD_3(KEY_KP_3),
    KEYPAD_4(KEY_KP_4),
    KEYPAD_5(KEY_KP_5),
    KEYPAD_6(KEY_KP_6),
    KEYPAD_7(KEY_KP_7),
    KEYPAD_8(KEY_KP_8),
    KEYPAD_9(KEY_KP_9),
    KEYPAD_PERIOD(KEY_KP_DECIMAL),
    KEYPAD_PLUS(KEY_KP_ADD),
    KEYPAD_MINUS(KEY_KP_SUBTRACT),
    KEYPAD_ASTERISK(KEY_KP_MULTIPLY),
    KEYPAD_SLASH(KEY_KP_DIVIDE),
    KEYPAD_EQUAL(KEY_KP_EQUAL),

    // Mouse keys
    MOUSE_LEFT(MOUSE_BUTTON_LEFT),
    MOUSE_RIGHT(MOUSE_BUTTON_RIGHT),
    MOUSE_MIDDLE(MOUSE_BUTTON_MIDDLE);

    @Getter
    private int keycode;

    private Keys(int keycode) {
        this.keycode = keycode;
    }
}
